// *** Relative shift variables
// These should allow to make it easier to create a light theme.
// By changing bases and directions, we should obtain a symmetric theme with the same hues.
$shift-pc-basis: 0%;
$shift-dir: 1;

@function shift-pc($pc) {
    @return $shift-pc-basis + $shift-dir * $pc;
}

// *** Defaults
// Text and colors hues
$text-hue: 0;
$accent-hue: 83;
// Blue variant: $accent-hue: 203;
$contrast-hue: 43;
$high-focus-hue: 3;
// Text and colors saturations
$text-saturation: 0%;
$colors-saturation: 100%;
// Text and colors lightnesses
$text-lightness: shift-pc(90%);
$menu-back-lightness: 23%;
$colors-lightness: shift-pc(23%);
$colored-text-lightness: shift-pc(65%);
// Some composites variables
$text-color: hsl($text-hue, $text-saturation, $text-lightness);
$accent-color: hsl($accent-hue, $colors-saturation, $colors-lightness);
$contrast-color: hsl($contrast-hue, $colors-saturation, $colors-lightness);

// *** Text color variations
$title-text-color: hsl($text-hue, $text-saturation, $text-lightness + $shift-dir * 5%);
$link-text-color: hsl($accent-hue, $colors-saturation - 30%, $colored-text-lightness);
$accent-text-color: hsl($accent-hue, $colors-saturation, $colored-text-lightness);
$contrast-text-color: hsl($contrast-hue, $colors-saturation, $colored-text-lightness + $shift-dir * 5%);
$muted-text-color: hsl($text-hue, $text-saturation, $text-lightness - $shift-dir * 15%);

// *** Green and red
$ok-hue: 123;
$ko-hue: 3;
$ok-text-color: hsl($ok-hue, $colors-saturation, shift-pc(75%));
$ko-text-color: hsl($ko-hue, $colors-saturation, shift-pc(75%));

// *** Backgrounds
$back-hue: 0;
$back-saturation: 0%;
$back-color-default: hsl($back-hue, $back-saturation, shift-pc(0%));
$back-color-content: hsl($back-hue, $back-saturation, shift-pc(10%));
$back-color-block: hsl($back-hue, $back-saturation, shift-pc(20%));

// *** Menus (header/footer)
$menu-back-color: hsl($back-hue, $back-saturation, $menu-back-lightness);
$menu-top-text-color: #fff;
$menu-foot-text-color: #fff;
$menu-header-color: hsl($accent-hue, 50%, $menu-back-lightness);
$menu-button-back-color: hsla(0, 0, 100%, 0.25);

// *** Other blocks
// Notices
$notice-back-color: hsl($accent-hue, $colors-saturation, shift-pc(10%));
$notice-text-color: $menu-top-text-color;
// Blockquote
$block-highlight-color: $accent-text-color;
$block-highlight-sign-color: hsla($accent-hue, $colors-saturation, $colored-text-lightness, 0.35);

// *** Forms
$input-text-color: $text-color;
$input-border-color: hsl($text-hue, $text-saturation, shift-pc(55%));
$input-back-color: hsl($back-hue, $back-saturation, shift-pc(25%));
$button-text-color: $text-color;
$button-border-color: $button-text-color;
$button-back-color: hsl($back-hue, $back-saturation, shift-pc(30%));

// ***SVG charts
// Color shift is the progressive shift from original color to final one
// We want 4 shifts (5 colours) to get to the complementary color (+180)
// That's 180 / 4 = 45
// The sign determines the side of the chromatic wheel we'll use
$hue-shift: -45;
$chart-colors: (
    neutral: hsl($back-hue, $back-saturation, shift-pc(30%)),
    accent: hsl($accent-hue, shift-pc(65%), shift-pc(55%)),
    contrast: hsl($contrast-hue, $colors-saturation, $colored-text-lightness),
    // FIXME 1 and accent are the same, create a mechanism for that
    1: hsl($accent-hue, shift-pc(65%), shift-pc(55%)),
    2: hsl(($accent-hue + 1 * $hue-shift) % 360, shift-pc(65%), shift-pc(55%)),
    3: hsl(($accent-hue + 2 * $hue-shift) % 360, shift-pc(65%), shift-pc(55%)),
    4: hsl(($accent-hue + 3 * $hue-shift) % 360, shift-pc(65%), shift-pc(55%)),
    5: hsl(($accent-hue + 4 * $hue-shift) % 360, shift-pc(65%), shift-pc(55%)),
);
$chart-color-focus: hsl($high-focus-hue, shift-pc(90%), shift-pc(55%));

// *** Code snippets
// Keyboard shortcuts
$code-text-color: $contrast-text-color;
$kbd-back-color: hsl($contrast-hue, $back-saturation, shift-pc(15%));
// Code highlighting
$code-saturation: $colors-saturation;
$code-lightness: 75%;
$code-color-keywords: hsl($contrast-hue, $code-saturation, $code-lightness);
$code-color-operators: hsl($ko-hue, $code-saturation, $code-lightness);
$code-color-namespaces: $code-color-operators;
$code-color-names: $text-color;
$code-color-tags: $code-color-operators;
$code-color-literals: hsl($accent-hue, $code-saturation, $code-lightness);
$code-color-constants: $code-color-literals;
$code-color-strings: hsl(203, $code-saturation, $code-lightness);
$code-color-numbers: $code-color-literals;
$code-color-comments: $muted-text-color;
$code-color-highlight-back: hsl($accent-hue, $colors-saturation, $text-lightness);

$separator-color: $muted-text-color;
